# Test environment

Once development has taken place, and rudimentary unit and system testing was
successful, a merge request is opened in the relevant Git repository. Once this
merge request is approved and included in upstream, it will be on the `develop`
branch.

The test environment is automatically re-deployed every hour on a VM
infrastructure in the GÉANT lab environment. This ensures that the test
environment always contains the newest versions of all components of GAP.

The test environment is meant for the GOAT to test new functionality and
the stability of GAP. The routers that are targeted, are virtual routers managed
by an EVE-NG instance. Once testing in the test environment has been concluded
successfully, GAP components are ready to advance to the UAT environment.

The test environment contains all development builds of components, following
semantic versioning principles.
