#!/bin/sh
set -o errexit
set -o nounset

export OSS_PARAMS_FILENAME=../gso/oss-params-example.json
export TESTING=true

pip install pyyaml mkdocstrings-python mkdocs_gen_files mkdocs-material mkdocs-literate-nav mkdocs-redirects
pip install -e ..
python ./scripts/gen_wf_redirects.py

mkdocs build --site-dir public
